竞赛图的常见性质/P3561 题解
竞赛图性质题。记 \(d_u\) 表示点 \(u\) 的入度。
考虑竞赛图的性质:
- 缩点后的 DAG 是链状的,且拓扑序小的 SCC 向拓扑序大的连边。
- 若 \(u\) 所在 SCC 的拓扑序小于 \(v\) 所在 SCC 的拓扑序,则 \(d_u<d_v\)。
- 把点按 \(d_u\) 升序排序后,\(\sum\limits_{j=1}^id_j=\binom i2\) 的点 \(i\) 到上一个满足此条件的点 \(p\) 之间的点 \((p,i]\) 构成一个 SCC。
- 竞赛图一定存在 Hamilton 通路,且可以 \(\mathcal{O}(n^2)\) 构造出。
- 强连通竞赛图一定存在 Hamilton 回路,且可以 \(\mathcal{O}(n^2)\) 构造出。
前两点性质比较简单,下面给出性质 3,4,5 的证明:
对于性质 3,根据性质 2,\([1,u]\) 会形成若干 SCC 和一个可能不完整的 SCC。当 \([1,u]\) 形成的 SCC 都是完整的时显然满足 \(\sum\limits_{j=1}^ud_j=\binom u2\),否则若 \(\sum\limits_{j=1}^ud_j=\binom u2\),若 SCC 不完整,在 \([1,u]\) 内部所有边的基础上,肯定会有外部的连边,LHS 的值 \(>\binom u2\),所以一定是完整的。
对于性质 4,考虑增量构造,设 \(1\sim u-1\) 的 Hamilton 通路 \(Q_1,Q_2,\dots,Q_{u-1}\),若存在 \(u\rightarrow Q_1\) 或 \(Q_{u-1}\rightarrow u\),直接接上去即可,否则存在 \(Q_1\rightarrow u\) 和 \(u\rightarrow Q_{u-1}\),此时一定存在 \(Q_i\rightarrow u \rightarrow Q_{i+1}\),否则可以推得对于所有 \(i\),存在 \(Q_i\rightarrow u\),矛盾。于是找到这样的 \(i\),接到 \(Q_i\) 和 \(Q_{i+1}\) 之间即可。时间复杂度 \(\mathcal{O}(n^2)\)。
对于性质 5,考虑先求出一条 Hamilton 通路 \(Q\),找到回路上最后一个 \(x\) 使得存在 \(Q_x\rightarrow Q_1\),由于图强连通,\(x\) 一定存在。那么初始有环 \(C=Q_1\rightsquigarrow Q_x\rightarrow Q_1\)。然后考虑增量构造,依次加入 \(u=Q_{x+1},\dots,Q_n\)。考虑维护一条链 \(P\) 为原先 \(Q\) 的一个后缀,且时刻满足 \(\forall x\in C,y\in P\),存在边 \((x,y)\)。如果当前 \(P=\varnothing\),当存在 \(u\rightarrow v, v\in C\) 时,由于 \(x\) 的最大性有 \(Q_1\rightarrow u\),类似性质 4 中的证明,可以把 \(u\) 插入环中,否则,把 \(u\) 接到 \(P\) 结尾,不改变 \(P\) 的性质。若 \(P\ne\varnothing\) 且 \(\not\exists u\rightarrow v, v\in C\),仍然考虑把 \(u\) 接入到 \(P\) 结尾,否则设 \(v\) 的前驱为 \(w\),由于 \(w\rightarrow p_1\) 存在,直接把 \(P\cup\{u\}\) 并入即可。最后由于 \(P\) 中的点都不可能到达 \(C\),而原图强连通,故 \(P\) 为空,Hamilton 回路存在,求解时间复杂度 \(\mathcal{O}(n^2)\)。
然后对于每个点 \(u\),找出 \(u\) 所在的 SCC 及拓扑序比 \(u\) 所在 SCC 大的 Hamilton 回路即可,时间复杂度 \(\mathcal{O}(n^2)\)。

浙公网安备 33010602011771号